/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code shows how to get the width and height of a widget. 
***************************************************************/

/* getsize.c */

#include <Xm/Xm.h>
#include <Xm/Label.h>

XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;

Widget toplevel, label;

main(argc,argv)
  int argc; 
  char *argv[];
{
  Arg al[10];
  int ac;
  Dimension w,h;

  /* create the toplevel shell */
  toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,
    NULL,NULL,0);

  /* Create the label */
  ac=0;
  XtSetArg(al[ac],XmNlabelString, 
    XmStringCreateLtoR("Hello Hello Hello Hello", char_set)); ac++;
  label=XmCreateLabel(toplevel,"label",al,ac);
  XtManageChild(label);

  /* get the width and height. */
  ac=0;
  XtSetArg(al[ac],XmNheight,&h); ac++;
  XtSetArg(al[ac],XmNwidth,&w); ac++;
  XtGetValues(label,al,ac);
  printf("%d %d \n",w,h);

  XtRealizeWidget(toplevel);
  XtAppMainLoop(context);
}
